/* --------------------------------------------------------------------
 Evaluation of kernel functions: linear, poly, rbf, sigmoidal.
-------------------------------------------------------------------- */

/* --- Exported global variables ----------------------------------- */

extern double *dataA;   /* pointer at the first pattern */
extern double *dataB;   /* pointer at the second pattern */
extern long dim;        /* dimension of patterns */
extern int ker;         /* kernel type (0 - linear, 1 - polynom, 2 - rbf */
extern double *arg1;    /* argument of the kernel */
extern long ker_cnt;    /* number of kernel evaluations */
extern char *kernel_name[]; /* kernel names */


/* --- Exported functions ------------------------------------------ */

/* --------------------------------------------------------------------
 Computes kernel function for a-th (dataA) and b-th (dataB)
-------------------------------------------------------------------- */
extern double kernel( long a, long b );

/* --------------------------------------------------------------------
 Converts string kernel identifier to int.
-------------------------------------------------------------------- */
int kernel_id( const mxArray *prhs1 );
